<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.17"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>SpaceFighter2020: LevelManager Class Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">SpaceFighter2020
   </div>
   <div id="projectbrief">This documentation reffers to the game Space Fighter 2020 created for pa2 course. Game is side-scrolling shooter where the goal is to get on the end of the level and kill as much as enemy ships as possible. Player can pick up bonuses for repairing point of health or upgrading his weapons.</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.17 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

</div><!-- top -->
<div class="header">
  <div class="summary">
<a href="#pub-methods">Public Member Functions</a> &#124;
<a href="#pub-static-methods">Static Public Member Functions</a> &#124;
<a href="#pri-methods">Private Member Functions</a> &#124;
<a href="#pri-attribs">Private Attributes</a> &#124;
<a href="classLevelManager-members.html">List of all members</a>  </div>
  <div class="headertitle">
<div class="title">LevelManager Class Reference</div>  </div>
</div><!--header-->
<div class="contents">

<p>Mayer singlton class of LevelMagager which manages loading of level and spawning enemies.  
 <a href="classLevelManager.html#details">More...</a></p>

<p><code>#include &lt;<a class="el" href="LevelManager_8h_source.html">LevelManager.h</a>&gt;</code></p>
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr class="memitem:a72ca9c27cc6b85143e20f83c520d1215"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classLevelManager.html#a72ca9c27cc6b85143e20f83c520d1215">~LevelManager</a> ()</td></tr>
<tr class="memdesc:a72ca9c27cc6b85143e20f83c520d1215"><td class="mdescLeft">&#160;</td><td class="mdescRight">Destroy the Level Manager object.  <a href="classLevelManager.html#a72ca9c27cc6b85143e20f83c520d1215">More...</a><br /></td></tr>
<tr class="separator:a72ca9c27cc6b85143e20f83c520d1215"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:afd79eedad898882d9a9f7f1e834c1776"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classLevelManager.html#afd79eedad898882d9a9f7f1e834c1776">Start</a> ()</td></tr>
<tr class="memdesc:afd79eedad898882d9a9f7f1e834c1776"><td class="mdescLeft">&#160;</td><td class="mdescRight">Start spawining enimies.  <a href="classLevelManager.html#afd79eedad898882d9a9f7f1e834c1776">More...</a><br /></td></tr>
<tr class="separator:afd79eedad898882d9a9f7f1e834c1776"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a7800611361e7c2ae99102e69429456fc"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classLevelManager.html#a7800611361e7c2ae99102e69429456fc">Update</a> ()</td></tr>
<tr class="memdesc:a7800611361e7c2ae99102e69429456fc"><td class="mdescLeft">&#160;</td><td class="mdescRight">Update messege from game loop spawns enemies if duration for spawning enemy has passed.  <a href="classLevelManager.html#a7800611361e7c2ae99102e69429456fc">More...</a><br /></td></tr>
<tr class="separator:a7800611361e7c2ae99102e69429456fc"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ab77bc4254643d9af9d8f64620167ab32"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classLevelManager.html#ab77bc4254643d9af9d8f64620167ab32">LoadLevel</a> (std::string fname)</td></tr>
<tr class="memdesc:ab77bc4254643d9af9d8f64620167ab32"><td class="mdescLeft">&#160;</td><td class="mdescRight">Loads level into a buffer.  <a href="classLevelManager.html#ab77bc4254643d9af9d8f64620167ab32">More...</a><br /></td></tr>
<tr class="separator:ab77bc4254643d9af9d8f64620167ab32"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:acd28c2069a392266fa9698ba4aba2a05"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classLevelManager.html#acd28c2069a392266fa9698ba4aba2a05">CheckEndOfMap</a> ()</td></tr>
<tr class="memdesc:acd28c2069a392266fa9698ba4aba2a05"><td class="mdescLeft">&#160;</td><td class="mdescRight">Checks whenever level is finished.  <a href="classLevelManager.html#acd28c2069a392266fa9698ba4aba2a05">More...</a><br /></td></tr>
<tr class="separator:acd28c2069a392266fa9698ba4aba2a05"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-static-methods"></a>
Static Public Member Functions</h2></td></tr>
<tr class="memitem:ac7fc80999d7cea3833244b858f75aeb0"><td class="memItemLeft" align="right" valign="top">static <a class="el" href="classLevelManager.html">LevelManager</a> &amp;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classLevelManager.html#ac7fc80999d7cea3833244b858f75aeb0">GetInstance</a> ()</td></tr>
<tr class="memdesc:ac7fc80999d7cea3833244b858f75aeb0"><td class="mdescLeft">&#160;</td><td class="mdescRight">Get the Instance object.  <a href="classLevelManager.html#ac7fc80999d7cea3833244b858f75aeb0">More...</a><br /></td></tr>
<tr class="separator:ac7fc80999d7cea3833244b858f75aeb0"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pri-methods"></a>
Private Member Functions</h2></td></tr>
<tr class="memitem:a5e12bdcc49e300a4e9f982e3c589f4fe"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classLevelManager.html#a5e12bdcc49e300a4e9f982e3c589f4fe">LevelManager</a> ()</td></tr>
<tr class="memdesc:a5e12bdcc49e300a4e9f982e3c589f4fe"><td class="mdescLeft">&#160;</td><td class="mdescRight">Private constructor to achiave singleton pattern.  <a href="classLevelManager.html#a5e12bdcc49e300a4e9f982e3c589f4fe">More...</a><br /></td></tr>
<tr class="separator:a5e12bdcc49e300a4e9f982e3c589f4fe"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a00727cc0a463c68e03773d0b99a45f2d"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classLevelManager.html#a00727cc0a463c68e03773d0b99a45f2d">ParseLine</a> (const std::string &amp;input, int &amp;time, int &amp;pos, int &amp;type)</td></tr>
<tr class="memdesc:a00727cc0a463c68e03773d0b99a45f2d"><td class="mdescLeft">&#160;</td><td class="mdescRight">Parses line input into output parameters.  <a href="classLevelManager.html#a00727cc0a463c68e03773d0b99a45f2d">More...</a><br /></td></tr>
<tr class="separator:a00727cc0a463c68e03773d0b99a45f2d"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a0aa5999183349ffa57929d90649cc2d9"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classLevelManager.html#a0aa5999183349ffa57929d90649cc2d9">ParseColumn</a> (std::string::const_iterator &amp;it, std::string::const_iterator end, int &amp;output)</td></tr>
<tr class="memdesc:a0aa5999183349ffa57929d90649cc2d9"><td class="mdescLeft">&#160;</td><td class="mdescRight">Parses collumn until field separator is met and saves it to the ouput parameter.  <a href="classLevelManager.html#a0aa5999183349ffa57929d90649cc2d9">More...</a><br /></td></tr>
<tr class="separator:a0aa5999183349ffa57929d90649cc2d9"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a31ec00edc2999008eaaba907d68d0250"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classLevelManager.html#a31ec00edc2999008eaaba907d68d0250">ClearData</a> ()</td></tr>
<tr class="memdesc:a31ec00edc2999008eaaba907d68d0250"><td class="mdescLeft">&#160;</td><td class="mdescRight">Clears buffer.  <a href="classLevelManager.html#a31ec00edc2999008eaaba907d68d0250">More...</a><br /></td></tr>
<tr class="separator:a31ec00edc2999008eaaba907d68d0250"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a0dd819f5e75373256abed6dbfdc686dc"><td class="memItemLeft" align="right" valign="top"><a class="el" href="classEnemy.html">Enemy</a> *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classLevelManager.html#a0dd819f5e75373256abed6dbfdc686dc">PopObject</a> ()</td></tr>
<tr class="memdesc:a0dd819f5e75373256abed6dbfdc686dc"><td class="mdescLeft">&#160;</td><td class="mdescRight">Pop Spawndata object from buffer and creates corresponding enemy.  <a href="classLevelManager.html#a0dd819f5e75373256abed6dbfdc686dc">More...</a><br /></td></tr>
<tr class="separator:a0dd819f5e75373256abed6dbfdc686dc"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pri-attribs"></a>
Private Attributes</h2></td></tr>
<tr class="memitem:af44b0e39305203531f089b8ab6459170"><td class="memItemLeft" align="right" valign="top">std::chrono::time_point&lt; std::chrono::system_clock &gt;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classLevelManager.html#af44b0e39305203531f089b8ab6459170">m_Clock</a></td></tr>
<tr class="separator:af44b0e39305203531f089b8ab6459170"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a59512bd8b61c6d42e72b4e19b996ce7d"><td class="memItemLeft" align="right" valign="top">std::list&lt; <a class="el" href="structSpawnData.html">SpawnData</a> * &gt;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classLevelManager.html#a59512bd8b61c6d42e72b4e19b996ce7d">m_ObjectToSpawn</a></td></tr>
<tr class="separator:a59512bd8b61c6d42e72b4e19b996ce7d"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a16da090cec97f6e3e0551ff85229bfc7"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classLevelManager.html#a16da090cec97f6e3e0551ff85229bfc7">m_EndOfMap</a></td></tr>
<tr class="separator:a16da090cec97f6e3e0551ff85229bfc7"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:acad7e80a4df9353e27dd46e80b3f58eb"><td class="memItemLeft" align="right" valign="top">const int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classLevelManager.html#acad7e80a4df9353e27dd46e80b3f58eb">m_TypesEnemies</a> = 4</td></tr>
<tr class="separator:acad7e80a4df9353e27dd46e80b3f58eb"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
<div class="textblock"><p>Mayer singlton class of LevelMagager which manages loading of level and spawning enemies. </p>
</div><h2 class="groupheader">Constructor &amp; Destructor Documentation</h2>
<a id="a72ca9c27cc6b85143e20f83c520d1215"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a72ca9c27cc6b85143e20f83c520d1215">&#9670;&nbsp;</a></span>~LevelManager()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">LevelManager::~LevelManager </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Destroy the Level Manager object. </p>

</div>
</div>
<a id="a5e12bdcc49e300a4e9f982e3c589f4fe"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a5e12bdcc49e300a4e9f982e3c589f4fe">&#9670;&nbsp;</a></span>LevelManager()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">LevelManager::LevelManager </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">private</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Private constructor to achiave singleton pattern. </p>

</div>
</div>
<h2 class="groupheader">Member Function Documentation</h2>
<a id="acd28c2069a392266fa9698ba4aba2a05"></a>
<h2 class="memtitle"><span class="permalink"><a href="#acd28c2069a392266fa9698ba4aba2a05">&#9670;&nbsp;</a></span>CheckEndOfMap()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">bool LevelManager::CheckEndOfMap </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Checks whenever level is finished. </p>

</div>
</div>
<a id="a31ec00edc2999008eaaba907d68d0250"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a31ec00edc2999008eaaba907d68d0250">&#9670;&nbsp;</a></span>ClearData()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void LevelManager::ClearData </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">private</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Clears buffer. </p>

</div>
</div>
<a id="ac7fc80999d7cea3833244b858f75aeb0"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ac7fc80999d7cea3833244b858f75aeb0">&#9670;&nbsp;</a></span>GetInstance()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classLevelManager.html">LevelManager</a> &amp; LevelManager::GetInstance </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">static</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Get the Instance object. </p>

</div>
</div>
<a id="ab77bc4254643d9af9d8f64620167ab32"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ab77bc4254643d9af9d8f64620167ab32">&#9670;&nbsp;</a></span>LoadLevel()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">bool LevelManager::LoadLevel </td>
          <td>(</td>
          <td class="paramtype">std::string&#160;</td>
          <td class="paramname"><em>fname</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Loads level into a buffer. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">fname</td><td>name of level file </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>true if file loaded correctly </dd>
<dd>
false if file has incorrect syntax </dd></dl>

</div>
</div>
<a id="a0aa5999183349ffa57929d90649cc2d9"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a0aa5999183349ffa57929d90649cc2d9">&#9670;&nbsp;</a></span>ParseColumn()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">bool LevelManager::ParseColumn </td>
          <td>(</td>
          <td class="paramtype">std::string::const_iterator &amp;&#160;</td>
          <td class="paramname"><em>it</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">std::string::const_iterator&#160;</td>
          <td class="paramname"><em>end</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int &amp;&#160;</td>
          <td class="paramname"><em>output</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">private</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Parses collumn until field separator is met and saves it to the ouput parameter. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">it</td><td>string const iterator from where function will start parsing </td></tr>
    <tr><td class="paramname">end</td><td>string const interator bound to which function will try to parse </td></tr>
    <tr><td class="paramname">output</td><td>output parameter int </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>true if input string has correct format </dd>
<dd>
false if input string has correct format </dd></dl>

</div>
</div>
<a id="a00727cc0a463c68e03773d0b99a45f2d"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a00727cc0a463c68e03773d0b99a45f2d">&#9670;&nbsp;</a></span>ParseLine()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">bool LevelManager::ParseLine </td>
          <td>(</td>
          <td class="paramtype">const std::string &amp;&#160;</td>
          <td class="paramname"><em>input</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int &amp;&#160;</td>
          <td class="paramname"><em>time</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int &amp;&#160;</td>
          <td class="paramname"><em>pos</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int &amp;&#160;</td>
          <td class="paramname"><em>type</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">private</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Parses line input into output parameters. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">input</td><td>string to parse by function </td></tr>
    <tr><td class="paramname">time</td><td>output parameter for time </td></tr>
    <tr><td class="paramname">pos</td><td>output parameter for position on Y axis </td></tr>
    <tr><td class="paramname">type</td><td>output parameter for type of enemy to spawn </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>true if input string has correct format </dd>
<dd>
false if input string has incorrect format </dd></dl>

</div>
</div>
<a id="a0dd819f5e75373256abed6dbfdc686dc"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a0dd819f5e75373256abed6dbfdc686dc">&#9670;&nbsp;</a></span>PopObject()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classEnemy.html">Enemy</a> * LevelManager::PopObject </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">private</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Pop Spawndata object from buffer and creates corresponding enemy. </p>
<dl class="section return"><dt>Returns</dt><dd>Enemy* created enemy from map </dd></dl>

</div>
</div>
<a id="afd79eedad898882d9a9f7f1e834c1776"></a>
<h2 class="memtitle"><span class="permalink"><a href="#afd79eedad898882d9a9f7f1e834c1776">&#9670;&nbsp;</a></span>Start()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void LevelManager::Start </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Start spawining enimies. </p>

</div>
</div>
<a id="a7800611361e7c2ae99102e69429456fc"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a7800611361e7c2ae99102e69429456fc">&#9670;&nbsp;</a></span>Update()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void LevelManager::Update </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Update messege from game loop spawns enemies if duration for spawning enemy has passed. </p>

</div>
</div>
<h2 class="groupheader">Member Data Documentation</h2>
<a id="af44b0e39305203531f089b8ab6459170"></a>
<h2 class="memtitle"><span class="permalink"><a href="#af44b0e39305203531f089b8ab6459170">&#9670;&nbsp;</a></span>m_Clock</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">std::chrono::time_point&lt;std::chrono::system_clock&gt; LevelManager::m_Clock</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">private</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p>Timer for screating enemies </p>

</div>
</div>
<a id="a16da090cec97f6e3e0551ff85229bfc7"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a16da090cec97f6e3e0551ff85229bfc7">&#9670;&nbsp;</a></span>m_EndOfMap</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">bool LevelManager::m_EndOfMap</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">private</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p>End of map state flag </p>

</div>
</div>
<a id="a59512bd8b61c6d42e72b4e19b996ce7d"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a59512bd8b61c6d42e72b4e19b996ce7d">&#9670;&nbsp;</a></span>m_ObjectToSpawn</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">std::list&lt;<a class="el" href="structSpawnData.html">SpawnData</a> *&gt; LevelManager::m_ObjectToSpawn</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">private</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p>Data buffer </p>

</div>
</div>
<a id="acad7e80a4df9353e27dd46e80b3f58eb"></a>
<h2 class="memtitle"><span class="permalink"><a href="#acad7e80a4df9353e27dd46e80b3f58eb">&#9670;&nbsp;</a></span>m_TypesEnemies</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">const int LevelManager::m_TypesEnemies = 4</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">private</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

</div>
</div>
<hr/>The documentation for this class was generated from the following files:<ul>
<li>src/<a class="el" href="LevelManager_8h_source.html">LevelManager.h</a></li>
<li>src/<a class="el" href="LevelManager_8cpp.html">LevelManager.cpp</a></li>
</ul>
</div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.17
</small></address>
</body>
</html>
